'''
Created on Feb 24, 2011

@author: Dirk Voesenek
'''

import arcpy,os,string,time

def log(msg):    
    f = open(logFile, 'a')    
    f.write(msg + '\r\n')
    f.close()

def HandleMsg(msg):
    """Sends a message to the ArcGIS process console including timestamp"""
    fmsg = '[%s] %s' % (time.strftime("%H:%M:%S"),msg)    
    arcpy.AddMessage(fmsg)
    if LOGGING: log(fmsg)
    
def HandleWarning(msg):
    """Sends a message to the ArcGIS process console including timestamp"""
    fmsg = '[%s] %s' % (time.strftime("%H:%M:%S"),msg)
    arcpy.AddWarning(fmsg)
    if LOGGING: log(fmsg)
        
def HandleError(msg):
    """Sends a message to the ArcGIS process console including timestamp"""
    fmsg = '[%s] %s' % (time.strftime("%H:%M:%S"),msg)
    arcpy.AddError(fmsg) 
    if LOGGING: log(fmsg)   
    sys.exit()

def GetLayerByName(mxd,layername):
    found = 0
    for lyr in arcpy.mapping.ListLayers(mxd):
        HandleMsg("Layer present: " + lyr.name)
        
        if lyr.name == layername:
            myLyr,found = lyr,1
    
    if found: return myLyr
    else: return None     
    
#inTable = arcpy.GetParameterAsText(0)
exportFolder = r"D:\Temp\PyMapping\Gemeentes"

#logFile = arcpy.GetParameterAsText(1)
logFile = '#'

# Setup logging
if logFile == '#': LOGGING = 0
else: LOGGING = 1


# Loop trough layers

mxd = arcpy.mapping.MapDocument("D:\Projecten\Python case\GemeenteKaart2.mxd")
gemeentelaag = GetLayerByName(mxd,"Gemeentes 2009")
gemeentelaag.visible = 0

filterlaag = GetLayerByName(mxd,"Filter")
filterlaag.visible = 1

# Apply definition query on gemeentes

layers = ["65plus", "Bevolkingsdichtheid", "Eenpersoonshuishoudens", "Woningen", "Autos"]


for layer in layers:
        
    
    #HandleMsg("Preparing map for dataobject '%s' (%s)..." % (dataobject,layer))

    themalayer = GetLayerByName(mxd,layer)
    themalayer.visible = 1
    
    # Use cursor for gemeentes laag

    gemeentes = arcpy.SearchCursor(gemeentelaag)

    for gemeente in gemeentes:
    
    	# Apply definition query on gemeentes en filter laag
        filterlaag.definitionQuery = "GM_NAAM <> '" + gemeente.GM_NAAM + "'"
        gemeentelaag.definitionQuery = "GM_NAAM = '" + gemeente.GM_NAAM + "'"    
        gemeenteExtent = gemeentelaag.getExtent()
        
        for df in arcpy.mapping.ListDataFrames(mxd):
            HandleMsg(df.name)
        if df.name == "Layers":            
            # df.panToExtent(gemeenteExtent)
            df.extent = gemeenteExtent

        for elm in arcpy.mapping.ListLayoutElements(mxd, "TEXT_ELEMENT"):
            if elm.name == "GemeenteTekst":
                elm.text = "Afgebeelde gemeente " + gemeente.GM_NAAM        
       
        outPath = exportFolder + "\\" + gemeente.GM_NAAM + "_" + layer
        arcpy.mapping.ExportToJPEG(mxd,outPath,"PAGE_LAYOUT",0,0,300)        
        HandleMsg("Exporting ..." + outPath)
            
    del gemeentes
    themalayer.visible = 0
    
    
    #for textElement in arcpy.mapping.ListLayoutElements(mxd, 'TEXT_ELEMENT'):
     #   #HandleMsg(textElement.name)
      #  if textElement.name == "Titel": textElement.text = title
       # elif textElement.name == "Omschrijving": textElement.text = descr 

    # Exporteren    
    
    #HandleMsg("Exporting to %s" % outPath)
    #arcpy.mapping.ExportToPDF(mxd, outPath)
    # 300 dpi jpeg
    
    
    # Make layer invisible
    #myLyr.visible = 0    
    
del mxd
HandleMsg("Ready!")